#include "Cjt_Estudiants.hpp"
#include <algorithm>

Cjt_estudiants::Cjt_estudiants()
{
  nest = 0;
  vest =  vector<Estudiant>(MAX_NEST);
}
  

Cjt_estudiants::~Cjt_estudiants(){}



/* Pre: vest[left..right] est ordenat creixentment per DNI,
0<=left, right<vest.size() */
int cerca_dicot(const vector<Estudiant> & vest, int left, int right, int x){
  int i; bool found=false;
while (left <= right) {
  i = (left + right)/2;
  if (x < vest[i].consultar_DNI()) right = i - 1;
  else if (x > vest[i].consultar_DNI()) left = i + 1;
  else return i;
 }
 return -1;
}
/* Post: si a vest[left..right] hi ha un element amb DNI = x, el resultat s
una posici que el cont; si no, el resultat s -1 */


/* Pre: el parmetre implcit no cont cap estudiant amb el dni d'est */
void Cjt_estudiants::afegir_estudiant(const Estudiant &est)
{
  int dni=est.consultar_DNI();
  int i = nest-1;
  while (i>=0 and dni < vest[i].consultar_DNI()) {
    vest[i+1]=vest[i];
    --i;
  }
  vest[i+1] = est;
  ++nest;
}
  /* Post: s'ha afegit l'estudiant est al parmetre implcit */


/* Pre: existeix un estudiant al parmetre implcit amb el DNI d'est  */
void Cjt_estudiants::modificar_estudiant(const Estudiant &est) {
  vest[cerca_dicot(vest,0,nest-1,est.consultar_DNI())]= est;
}    
/* Post: l'estudiant del parmetre implcit original amb el dni
   d'est, ha quedat substitut per est */
  		

/* Pre: 1 <= i <= nombre d'estudiants del parmetre implcit,
   l'element i-ssim del conjunt en ordre creixent per DNI cont 
   un estudiant amb el mateix DNI que est */
void Cjt_estudiants::modificar_iessim(int i, const Estudiant &est) {
  vest[i-1]= est;
}
/* Post: l'estudiant est ha substitut l'estudiant i-ssim
   del parmetre implcit */
  

int Cjt_estudiants::mida() const
{
  return nest;
}
/* Post: el resultat s el nombre d'estudiants del parmetre implcit */


/* Pre: dni > 0 */
bool Cjt_estudiants::existeix_estudiant(int dni) const {
  int i = cerca_dicot(vest,0,nest-1,dni);
  return (i!=-1);
}
/* Post: el resultat indica si existeix un estudiant al parmetre implcit
   amb DNI = dni */


/* Pre: 1 <= i <= nombre d'estudiants que cont el parmetre implcit */
Estudiant Cjt_estudiants::consultar_estudiant(int dni) const {
  return vest[cerca_dicot(vest,0,nest-1,dni)];
}
/* Post: el resultat s l'estudiant i-ssim del parmetre implcit 
   en ordre creixent per DNI */
 
/* Pre: 1 <= i <= nombre d'estudiants que cont el parmetre implcit */
Estudiant Cjt_estudiants::consultar_iessim(int i) const {
  return vest[i-1];
}
/* Post: el resultat s l'estudiant i-ssim del parmetre implcit 
   en ordre creixent per DNI */


void Cjt_estudiants::llegir_cjt_estudiants(){
  cout << "Escriu la mida del conjunt" << endl;
  cin >> nest;
  for (int i=0; i<nest; ++i)
    vest[i].llegir_estudiant();
  ordenar_cjt_estudiants();
}
/* Post: el parmetre implcit cont el conjunt d'estudiants llegits
   del canal estndard d'entrada */


void Cjt_estudiants::escriure_cjt_estudiants() const{
  for (int i=0; i<nest; ++i)
    vest[i].escriure_estudiant();
}
/* Post: s'han escrit pel canal estndard de sortida els estudiants del
   parmetre implcit en ordre ascendent per DNI */




bool comp(Estudiant e1, Estudiant e2) {
  return (e1.consultar_DNI() < e2.consultar_DNI());
}

void Cjt_estudiants::ordenar_cjt_estudiants(){
  sort(vest.begin(),vest.begin()+nest, comp);
}



